/**************************************************************************
usbHost with 2.4G Joystick libary
Copyright (C) Hartley Maker Space - www.ededu.org
Author: Ampear Lee
Email: bd5qdm@gmail.com
Version:1.0
**************************************************************************/
#include <Arduino.h>
#include "UsbHostJoyPad.h"

UsbHostJoyPad::UsbHostJoyPad(uint8_t port) : MeUSBHost(port)
{
  ;
}

int16_t UsbHostJoyPad::JoyAnalog(uint8_t button)
{
  
  
    if(button == MeJOYSTICK_RX || button == MeJOYSTICK_RY || button == MeJOYSTICK_LX || button == MeJOYSTICK_LY)
    {
      result = 2*(ps2_data_list[button]-128);
      if((button == MeJOYSTICK_RY) || (button == MeJOYSTICK_LY))
      {
        result = -result;
      }
      if((result == -256) || (result == -254))
      {
        result = -255;
      }
      else if((result == 254) || (result == 256))
      {
        result = 255;
      }
      return result;
    }
    else
    {
      return MeJOYSTICK_INIT_VALUE;
    }
  
  
}

void UsbHostJoyPad::ParseJoypad(unsigned char *buf) //print the data from USB Host
{
  int i = 0;
  for(i = 0; i < 7; i++)
  {
    Serial.print(buf[i]);  //It won't work if you connect to the Makeblock Orion.
    Serial.print('-');
  }
  Serial.println(buf[7]);
  delay(10);
}

bool UsbHostJoyPad::ButtonPressed(uint8_t button) 
{
  return  ps2_data_list[button];
}

void UsbHostJoyPad::loop(void)
{
  
  if(!MeUSBHost::device_online)
  {
    
	MeUSBHost::probeDevice(); //轮询USB设备
    delay(100);
	
  }
  else
  {
//接收USB设备的数据
    
	len = MeUSBHost::host_recv();
	if (len > 4)
	{
    //ParseJoypad(MeUSBHost::RECV_BUFFER);     
	 
    ps2_data_list[MeJOYSTICK_LX] = MeUSBHost::RECV_BUFFER[2];  // 右X-右Y-左X-左Y-15-0-0-128
    ps2_data_list[MeJOYSTICK_LY] = MeUSBHost::RECV_BUFFER[3];  // 右X-右Y-左X-左Y-15-0-0-128
    ps2_data_list[MeJOYSTICK_RX] = MeUSBHost::RECV_BUFFER[0];  // 右X-右Y-左X-左Y-15-0-0-128
    ps2_data_list[MeJOYSTICK_RY] = MeUSBHost::RECV_BUFFER[1];  // 右X-右Y-左X-左Y-15-0-0-128
    
	ps2_data_list[MeJOYSTICK_R1] = MeUSBHost::RECV_BUFFER[5] == 0x02 ? true : false;  // 128-127-128-127-15-2-0-128 128-127-128-127-15-2-0-128
    ps2_data_list[MeJOYSTICK_R2] = MeUSBHost::RECV_BUFFER[5] == 0x08 ? true : false;  // 128-127-128-127-15-8-0-128 128-127-128-127-15-8-0-128
    ps2_data_list[MeJOYSTICK_L1] = MeUSBHost::RECV_BUFFER[5] == 0x01 ? true : false;  // 128-127-128-127-15-1-0-128 128-127-128-127-15-1-0-128
    ps2_data_list[MeJOYSTICK_L2] = MeUSBHost::RECV_BUFFER[5] == 0x04 ? true : false;  // 128-127-128-127-15-4-0-128 128-127-128-127-15-4-0-128
    
	ps2_data_list[MeJOYSTICK_SELECT] = MeUSBHost::RECV_BUFFER[5] == 0x10 ? true : false ;  // 128-127-128-127-15-16-0-128 128-127-128-127-15-16-0-128
	ps2_data_list[MeJOYSTICK_MODE] = MeUSBHost::RECV_BUFFER[5] ==0x00 ? true : false;      // 128-127-128-127-15-0-0-128 128-127-128-127-15-0-1-128
    ps2_data_list[MeJOYSTICK_START] = MeUSBHost::RECV_BUFFER[5] == 0x20 ? true : false;    // 128-127-128-127-15-32-0-128 128-127-128-127-15-32-0-128
	
	ps2_data_list[MeJOYSTICK_TRIANGLE] = MeUSBHost::RECV_BUFFER[4] == 0x1F ? true : false; // 128-127-128-127-31-0-0-128 （0001 1111）128-127-128-127-31-0-0-128
    ps2_data_list[MeJOYSTICK_XSHAPED] = MeUSBHost::RECV_BUFFER[4] == 0x4F ? true : false;  // 128-127-128-127-79-0-0-128 （0100 1111）128-127-128-127-79-0-0-128
    ps2_data_list[MeJOYSTICK_SQUARE] = MeUSBHost::RECV_BUFFER[4] == 0x8F ? true : false;   // 128-127-128-127-143-0-0-128 （1000 1111）128-127-128-127-143-0-0-128
    ps2_data_list[MeJOYSTICK_ROUND] = MeUSBHost::RECV_BUFFER[4] == 0x2F ? true : false;    // 128-127-128-127-47-0-0-128 （0010 1111）128-127-128-127-47-0-0-128
    
    
	ps2_data_list[MeJOYSTICK_UP] = MeUSBHost::RECV_BUFFER[3] == 0x00 ? true : false;       // 128-128-128-0-15-0-0-128 （0000 0000） 128-127-128-127-0-0-0-128
    ps2_data_list[MeJOYSTICK_DOWN] = MeUSBHost::RECV_BUFFER[3] == 0xFF ? true : false ;    // 128-128-128-255-15-0-0-128 （0000 0100）128-127-128-127-4-0-0-128
    ps2_data_list[MeJOYSTICK_LEFT] = MeUSBHost::RECV_BUFFER[2] == 0x00 ? true : false ;    // 128-128-0-128-15-0-0-128 （0000 0110） 128-127-128-127-6-0-0-128
    ps2_data_list[MeJOYSTICK_RIGHT] = MeUSBHost::RECV_BUFFER[2] == 0xFF ? true : false ;   // 128-128-255-128-15-0-0-128 128-127-128-127-2-0-0-128

    
	ps2_data_list[MeJOYSTICK_BUTTON_L] = MeUSBHost::RECV_BUFFER[5] == 0x40 ? true : false ;// 128-127-128-127-15-64-0-128 128-127-128-127-15-64-0-128
    ps2_data_list[MeJOYSTICK_BUTTON_R] = MeUSBHost::RECV_BUFFER[5] == 0x80 ? true : false ;// 128-127-128-127-15-128-0-128 128-127-128-127-15-128-0-128
	}
   }
 }

