/**************************************************************************/
/*!
usbHost with 2.4G Joystick libary
Copyright (C) Hartley Maker Space - www.ededu.org
Author: Ampear Lee
Email: bd5qdm@gmail.com
Version:1.0
 */
/**************************************************************************/
#ifndef USBHOST_JOYPAD_H_
#define USBHOST_JOYPAD_H_


#include <Arduino.h>
#include <MeUSBHost.h>

#define MeJOYSTICK_RX           6
#define MeJOYSTICK_RY           8
#define MeJOYSTICK_LX           2
#define MeJOYSTICK_LY           4

#define MeJOYSTICK_R1           1
#define MeJOYSTICK_R2           3
#define MeJOYSTICK_L1           5
#define MeJOYSTICK_L2           7
#define MeJOYSTICK_TRIANGLE     9
#define MeJOYSTICK_XSHAPED      10
#define MeJOYSTICK_SQUARE       11
#define MeJOYSTICK_ROUND        12
#define MeJOYSTICK_START        13
#define MeJOYSTICK_UP           14
#define MeJOYSTICK_DOWN         15
#define MeJOYSTICK_LEFT         16
#define MeJOYSTICK_RIGHT        17
#define MeJOYSTICK_SELECT       18
#define MeJOYSTICK_MODE         19
#define MeJOYSTICK_BUTTON_L     20
#define MeJOYSTICK_BUTTON_R     21
#define MeJOYSTICK_INIT_VALUE   0
#define MeJOYSTICK_ANALOG_ERROR 0


class UsbHostJoyPad : public MeUSBHost
{

public:
  UsbHostJoyPad(uint8_t port);
  int16_t JoyAnalog(uint8_t button);
  void ParseJoypad(unsigned char *buf);
  bool ButtonPressed(uint8_t button);
  void loop(void);

private:
  uint8_t len;
  uint8_t ps2_data_list[23];
  int16_t result;
};

#endif 